osl Namespace Reference

## Namespaces

namespace | effect_util
namespace | misc
namespace | container
namespace | rating
namespace | effect
namespace | checkmate
namespace | book
namespace | detail
namespace | csa
| CSA形式.
namespace | enter_king
namespace | eval
namespace | hash
namespace | mobility
namespace | move_classifier
namespace | move_generator
namespace | effect_action
namespace | move_action
namespace | progress
namespace | usi
namespace | psn
| gnushogi で使われるフォーマット.
namespace | move_probability
namespace | stat
namespace | record
| 棋譜関係
namespace | kakinoki
namespace | ki2

## Classes

class | Offset
| 座標の差分 More...
class | Square
class | Piece
| 駒. More...
class | Move
| 圧縮していない moveの表現 . More...
class | BoardTable
struct | Centering5x3
| 5x3が盤上におさまるように中心を調整 More...
struct | DirectionTraitsGen
struct | DirectionTraitsGen< UL >
struct | DirectionTraitsGen< U >
struct | DirectionTraitsGen< UR >
struct | DirectionTraitsGen< L >
struct | DirectionTraitsGen< R >
struct | DirectionTraitsGen< DL >
struct | DirectionTraitsGen< D >
struct | DirectionTraitsGen< DR >
struct | DirectionTraitsGen< UUL >
struct | DirectionTraitsGen< UUR >
struct | DirectionTraitsGen< LONG_UL >
struct | DirectionTraitsGen< LONG_U >
struct | DirectionTraitsGen< LONG_UR >
struct | DirectionTraitsGen< LONG_L >
struct | DirectionTraitsGen< LONG_R >
struct | DirectionTraitsGen< LONG_DL >
struct | DirectionTraitsGen< LONG_D >
struct | DirectionTraitsGen< LONG_DR >
struct | DirectionTraits
struct | DirectionPlayerTraits
struct | DirectionPlayerTraits< Dir, BLACK >
struct | DirectionPlayerTraits< Dir, WHITE >
class | EffectContent
class | Offset32Base
| 差が uniqになるような座標の差分. More...
class | PieceMask
| 駒番号のビットセット. More...
class | PieceStand
| 片方の手番の持駒の枚数を記録するクラス. More...
struct | PieceStandIO
class | PieceTable
class | PtypeTable
struct | PtypeTraits
struct | PtypeTraits< PTYPE_EMPTY >
struct | PtypeTraits< PTYPE_EDGE >
struct | PtypeTraits< GOLD >
struct | PtypeTraits< PAWN >
struct | PtypeTraits< PPAWN >
struct | PtypeTraits< LANCE >
struct | PtypeTraits< PLANCE >
struct | PtypeTraits< KNIGHT >
struct | PtypeTraits< PKNIGHT >
struct | PtypeTraits< SILVER >
struct | PtypeTraits< PSILVER >
struct | PtypeTraits< BISHOP >
struct | PtypeTraits< PBISHOP >
struct | PtypeTraits< ROOK >
struct | PtypeTraits< PROOK >
struct | PtypeTraits< KING >
struct | PtypeFunsSub
struct | PtypeFunsSub< T, true >
struct | PtypeFunsSub< T, false >
struct | PtypeFuns
struct | PtypeDirectionTraits
struct | KingTraits
struct | PtypePlayerTraits
struct | SquareCompressor
| Square を [0..81] に圧縮する 0: 駒台，1..81 盤上 More...
struct | PieceBasicLessThan
struct | PiecePtypeMoreThan
class | CArray
class | FixedCapacityVector
class | MoveVector
class | CheckMoveVector
class | PieceVector
class | PtypeOSquareVector
struct | RecordMinimal
struct | IntArrayReader
struct | ShouldPromoteCut
| 探索で前向き枝刈して良い条件を一時的に書いておく More...
struct | GenerateAllMoves
struct | GenerateEscapeKing
class | NumEffectState
| 利きを持つ局面 More...
struct | OslConfig
| osl の実行環境に関する指定 More...
struct | SetUpRegister
struct | NoMoreMemory
class | SimpleState
struct | Centering3x3
| 3x3が盤上におさまるように中心を調整 More...
struct | LogProbCompare
class | MoveLogProb
class | PathEncodingTable
class | PathEncoding
class | RepetitionCounter
| 千日手の検出. More...
class | Sennichite
struct | AdditionalEffect
| 追加利きを求める More...
struct | Int2Type
struct | Player2Type
class | BitXmask
| X座標のbitset. More...
class | BoardMask
| 11 x 12 More...
class | EffectedNumTable
class | King8Info
| 敵玉の8近傍の状態を表す. More...
struct | BitOp
class | NumBitmapEffect
| 現在の定義 (2005/3/4以降) More...
class | PieceMask64
struct | QuadInt
class | QuadIntPair
class | BookInMemory
class | CompactBoard
| SimpleStateよりcompactな局面の表現 More...
class | WeightedBook
| StateとWMoveを保持する. More...
class | ImmediateCheckmate
class | ProofDisproof
| 証明数(proof number)と反証数(disproof number). More...
class | FixedCapacityVectorPushBack
struct | CsaIOError
class | CsaFileMinimal
class | CsaString
struct | EnterKing
struct | EvalTraits
class | OpenMidEndingEval
struct | See
class | HashKey
class | HashGenTable
class | KingMobility
class | MobilityTable
| 駒番号からMobilityContentを得る More...
struct | GenerateCapture
| Capture の Player で特殊化できないバージョン． More...
struct | GenerateEscape
struct | GeneratePieceOnBoard
class | NewProgress
class | DualDfpn
| 一般用詰み探索: 先手後手の詰みを別々に管理 More...
class | MoveLogProbVector
class | MoveStack
| Move のstack. More...
struct | Square8
class | Neighboring8Direct
| 8近傍への直接の利きを判定する More...
struct | SendOffSquare
| 送り金のような玉で取ると利きがはずれる駒が発生するマスを調査 More...
struct | ShadowEffect
| 影利きを求める More...
class | HashKeyStack
class | HashRandomPair
class | AtomicCounter
struct | IconvConvert
class | LightMutex
class | PtypeProgress
class | RatedMove
class | RatedMoveVector
class | RatingEnv
class | CsaFile
class | KakinokiFile
struct | KakinokiIOError
class | KanjiMove
| Parse kanji records such as "７六歩", the style of which is generally used to write Shogi records in Japanese. More...
class | Ki2File
| 「.ki2」という拡張子を持つ2ch形式ファイル. More...
struct | Ki2IOError
class | KisenFile
| 「.kif」という拡張子を持つ棋泉形式ファイル. More...
class | KisenIpxFile
| 「.ipx」という拡張子を持つ棋泉形式ファイル. More...
class | KisenWriter
class | KisenIpxWriter
| 「.ipx」という拡張子を持つ棋泉形式ファイル. More...
struct | SearchInfo
struct | Record
class | RecordFile
class | UsiFile
class | Average
| incrementaly maintain average of data sequence More...
class | Histogram
| ヒストグラム More...

## Typedefs

typedef Offset32Base< 8, 9 > | Offset32
typedef Offset32Base< 10, 10 > | Offset32Wide
typedef PieceMask64 | PieceMaskBase
template<typename T, size_t Capacity1, size_t Capacity2>
using | CArray2d = CArray<CArray<T,Capacity2>,Capacity1>
template<typename T, size_t Capacity1, size_t Capacity2, size_t Capacity3>
using | CArray3d = CArray<CArray2d<T,Capacity2,Capacity3>,Capacity1>
typedef QuadInt | MultiInt
typedef QuadIntPair | MultiIntPair
typedef unsigned long long | mask_int_t
typedef GeneralMask< mask_int_t > | mask_t
typedef GeneralMask< unsigned long long > | Mask64
typedef BoardKey96 | BoardKey
typedef ProgressN< 16 > | Progress16
typedef ProgressN< 32 > | Progress32
typedef std::chrono::high_resolution_clock | clock
typedef std::chrono::time_point< clock > | time_point
typedef std::chrono::milliseconds | milliseconds

## Enumerations

enum | Player { BLACK =0 , WHITE = -1 }
enum | Ptype { PTYPE_EMPTY =0 , PTYPE_EDGE =1 , PPAWN =2 , PLANCE =3 , PKNIGHT =4 , PSILVER =5 , PBISHOP =6 , PROOK =7 , KING =8 , GOLD =9 , PAWN =10 , LANCE =11 , KNIGHT =12 , SILVER =13 , BISHOP =14 , ROOK =15 , PTYPE_MIN =0 , PTYPE_BASIC_MIN =KING , PTYPE_PIECE_MIN =2 , PTYPE_MAX =15 }
| 駒の種類を4ビットでコード化する More...
enum | PtypeO { PTYPEO_MIN = PTYPE_EMPTY-16 , PTYPEO_MAX = 15 }
| Player + Ptype [-15, 15] PtypeO の O は Owner の O. More...

enum

Direction {
SHORT_DIRECTION_MIN =0 , SHORT8_DIRECTION_MIN =0 , UL =0 , U =1 ,
UR =2 , L =3 , R =4 , DL =5 ,
D =6 , DR =7 , SHORT8_DIRECTION_MAX =7 , UUL =8 ,
UUR =9 , LONG_DIRECTION_MIN =10 , LONG_UL =10 , LONG_U =11 ,
LONG_UR =12 , LONG_L =13 , LONG_R =14 , LONG_DL =15 ,
LONG_D =16 , LONG_DR =17 , LONG_DIRECTION_MAX =17 , DIRECTION_MIN =0 ,
SHORT_DIRECTION_MAX =9 , SHORT_DIRECTION_SIZE =10 , DIRECTION_MAX =17 , DIRECTION_INVALID_VALUE =18 ,
DIRECTION_SIZE =18
}

enum | Move16 { MOVE16_NONE = 0 }
| 16bit 表現 More...
enum | MoveConstraint { CannotMove , OnlyPromoted , OnlyBasic , NoConstraint }
| ある方向にある駒が移動可能かを表す. More...
enum | { CheckOrEscapeMaxUniqMoves = Move::MaxUniqMoves/4 }
enum | Handicap { HIRATE }

## Functions

constexpr Player | alt (Player player)
constexpr int | playerToIndex (Player player)
constexpr Player | indexToPlayer (int n)
constexpr int | sign (Player player)
constexpr int | playerToMask (Player player)
int | operator+ (Player, int)
int | operator+ (int, Player)
int | operator- (Player, int)
int | operator- (int, Player)
int | operator* (Player, int)
int | operator* (int, Player)
int | operator/ (Player, int)
int | operator/ (int, Player)
bool | isValid (Player player)
| cast等で作られたplayerが正しいかどうかを返す
std::ostream & | operator<< (std::ostream &os, Player player)
std::istream & | operator>> (std::istream &is, Ptype &ptype)
std::ostream & | operator<< (std::ostream &os, const Ptype ptype)
bool | isValid (Ptype ptype)
| int等からcastして作ったptypeが，正しい範囲に入っているかどうかのチェック
constexpr bool | isPiece (Ptype ptype)
| ptypeが空白やEDGEでないかのチェック
bool | isBasic (Ptype ptype)
| ptypeが基本型(promoteしていない)かのチェック
bool | isPromoted (Ptype ptype)
| ptypeがpromote後の型かどうかのチェック
bool | canPromote (Ptype ptype)
| ptypeがpromote可能な型かどうかのチェック promote済みの場合はfalseを返す
Ptype | unpromote (Ptype ptype)
| ptypeがpromote後の型の時に，promote前の型を返す． promoteしていない型の時はそのまま返す
constexpr Ptype | unpromoteSafe (Ptype ptype)
Ptype | promote (Ptype ptype)
| promote可能なptypeに対して，promote後の型を返す promote不可のptypeを与えてはいけない．
bool | isMajorBasic (Ptype ptype)
bool | isMajor (Ptype ptype)
bool | isMajorNonPieceOK (Ptype ptype)
unsigned int | ptypeOIndex (PtypeO ptypeo)
PtypeO | newPtypeO (Player player, Ptype ptype)
Ptype | getPtype (PtypeO ptypeO)
PtypeO | promote (PtypeO ptypeO)
| pieceをpromoteさせる.
PtypeO | promoteWithMask (PtypeO ptypeO, int promoteMask)
| pieceを引数次第でpromoteさせる
PtypeO | unpromote (PtypeO ptypeO)
| pieceをunpromoteさせる.
bool | isValidPtypeO (int ptypeO)
bool | isPiece (PtypeO ptypeO)
| EMPTY, EDGEではない
Player | getOwner (PtypeO ptypeO)
PtypeO | captured (PtypeO ptypeO)
| unpromoteすると共に，ownerを反転する．
PtypeO | alt (PtypeO ptypeO)
| owner を反転する
PtypeO | altIfPiece (PtypeO ptypeO)
| Pieceの時にはowner を反転する
bool | canPromote (PtypeO ptypeO)
bool | isPromoted (PtypeO ptypeO)
| ptypeOが promote済みかどうか
const PtypeO PTYPEO_EDGE | __attribute__ ((unused))
std::ostream & | operator<< (std::ostream &os, const PtypeO ptypeO)
constexpr bool | isShort (Direction d)
constexpr bool | isShort8 (Direction d)
constexpr bool | isLong (Direction d)
constexpr Direction | inverseUnsafe (Direction d)
constexpr Direction | inverse (Direction d)
constexpr Direction | primDir (Direction d)
| 8方向について，primitiveな4方向を求める
constexpr Direction | primDirUnsafe (Direction d)
| 8方向について，primitiveな4方向を求める dとしてknight, INVALIDなども来る
bool | isValid (Direction d)
constexpr Direction | longToShort (Direction d)
constexpr Direction | shortToLong (Direction d)
| 引数に longDirを与えてはいけない
constexpr int | dirToMask (Direction dir)
std::ostream & | operator<< (std::ostream &os, const Direction d)
bool | operator== (Square l, Square r)
Offset | newOffset (int dx, int dy)
| @obsolete
bool | operator== (Offset l, Offset r)
bool | operator!= (Offset l, Offset r)
bool | operator< (Offset l, Offset r)
std::ostream & | operator<< (std::ostream &, Offset)
bool | operator!= (Square l, Square r)
bool | operator< (Square l, Square r)
bool | operator> (Square l, Square r)
std::ostream & | operator<< (std::ostream &, Square)
bool | operator== (Piece l, Piece r)
bool | operator< (Piece l, Piece r)
bool | operator!= (Piece l, Piece r)
std::ostream & | operator<< (std::ostream &os, const Piece piece)
bool | operator< (Move lhs, Move rhs)
bool | operator== (Move lhs, Move rhs)
bool | operator!= (Move lhs, Move rhs)
std::ostream & | operator<< (std::ostream &os, Move move)
bool | operator== (EffectContent l, EffectContent r)
bool | operator!= (EffectContent l, EffectContent r)
bool | operator< (EffectContent l, EffectContent r)
const PieceMask | operator& (const PieceMask &m1, const PieceMask &m2)
const PieceMask | operator| (const PieceMask &m1, const PieceMask &m2)
const PieceMask | operator~ (const PieceMask &m1)
bool | operator== (const PieceMask &m1, const PieceMask &m2)
bool | operator!= (const PieceMask &m1, const PieceMask &m2)
std::ostream & | operator<< (std::ostream &os, PieceMask const &pieceMask)
bool | operator== (PieceStand l, PieceStand r)
bool | operator!= (PieceStand l, PieceStand r)
bool | operator< (PieceStand l, PieceStand r)
std::ostream & | operator<< (std::ostream &, PieceStand l)
template<typename T, size_t C>
bool | operator== (const FixedCapacityVector< T, C > &l, const FixedCapacityVector< T, C > &r)
template<typename T, size_t C>
bool | operator< (const FixedCapacityVector< T, C > &l, const FixedCapacityVector< T, C > &r)
std::ostream & | operator<< (std::ostream &os, MoveVector const &mv)
bool | operator< (const MoveVector &l, const MoveVector &r)
std::ostream & | operator<< (std::ostream &os, const PieceVector &)
bool | operator== (const NumEffectState &st1, const NumEffectState &st2)
| 駒番に依存した局面（インスタンス）比較をする.
bool | operator!= (const NumEffectState &s1, const NumEffectState &s2)
std::ostream & | operator<< (std::ostream &os, const SimpleState &state)
bool | operator== (const SimpleState &st1, const SimpleState &st2)
| 盤上の駒のみを比較する（持ち駒は見ない）.
std::ostream & | operator<< (std::ostream &os, MoveLogProb const &moveLogProb)
bool | operator== (MoveLogProb const &lhs, MoveLogProb const &rhs)
bool | operator< (MoveLogProb const &lhs, MoveLogProb const &rhs)
bool | operator== (const PathEncoding &l, const PathEncoding &r)
bool | operator!= (const PathEncoding &l, const PathEncoding &r)
std::ostream & | operator<< (std::ostream &, const PathEncoding &)
bool | operator== (const Sennichite &l, const Sennichite &r)
std::ostream & | operator<< (std::ostream &, const Sennichite &)
unsigned int | random ()
unsigned int | time_seeded_random ()
double | elapsedSeconds (time_point start)
template<class Duration>
double | toSeconds (Duration duration)
template<class Duration>
long long | msec (Duration duration)

## Variables

const int | PTYPE_SIZE =PTYPE_MAX-PTYPE_MIN+1
const PtypeO | PTYPEO_EMPTY =newPtypeO(BLACK,PTYPE_EMPTY)
const int | PTYPEO_SIZE =PTYPEO_MAX-PTYPEO_MIN+1
const int | EMPTY_NUM =0x80
const int | EDGE_NUM =0x40
const BoardTable | Board_Table
template<Direction Dir>
const Direction | DirectionPlayerTraits< Dir, BLACK >::directionByBlack
template<Direction Dir>
const Direction | DirectionPlayerTraits< Dir, WHITE >::directionByBlack
const PieceTable | Piece_Table
const PtypeTable | Ptype_Table
const int | NStages = 4
const int | EvalStages = 4
const int | EndgameIndex = EvalStages-1
PathEncodingTable | Path_Encoding_Table
const BoardMaskTable5x5 | Board_Mask_Table5x5
const BoardMaskTable5x3Center | Board_Mask_Table5x3_Center
const BoardMaskTable3x3 | Board_Mask_Table3x3

## Typedef Documentation

## BoardKey

typedef BoardKey96 osl::hash::BoardKey

Definition at line 151 of file hashKey.h.

## CArray2d

template<typename T, size_t Capacity1, size_t Capacity2>

using osl::CArray2d = CArray<CArray<T,Capacity2>,Capacity1>

Definition at line 95 of file container.h.

## CArray3d

template<typename T, size_t Capacity1, size_t Capacity2, size_t Capacity3>

using osl::CArray3d = CArray<CArray2d<T,Capacity2,Capacity3>,Capacity1>

Definition at line 98 of file container.h.

## clock

typedef std::chrono::high_resolution_clock osl::misc::clock

Definition at line 17 of file milliSeconds.h.

## Mask64

typedef GeneralMask<unsigned long long> osl::misc::Mask64

Definition at line 347 of file mask.h.

## mask_int_t

typedef unsigned long long osl::misc::mask_int_t

Definition at line 350 of file mask.h.

## mask_t

typedef GeneralMask<mask_int_t> osl::misc::mask_t

Definition at line 351 of file mask.h.

## milliseconds

typedef std::chrono::milliseconds osl::misc::milliseconds

Definition at line 19 of file milliSeconds.h.

## MultiInt

typedef QuadInt osl::MultiInt

Definition at line 13 of file midgame.h.

## MultiIntPair

typedef QuadIntPair osl::MultiIntPair

Definition at line 14 of file midgame.h.

## Offset32

typedef Offset32Base<8,9> osl::Offset32

Definition at line 63 of file offset32.h.

## Offset32Wide

typedef Offset32Base<10,10> osl::Offset32Wide

Definition at line 64 of file offset32.h.

## PieceMaskBase

typedef PieceMask64 osl::PieceMaskBase

Definition at line 12 of file pieceMask.h.

## Progress16

typedef ProgressN<16> osl::progress::Progress16

Definition at line 42 of file progress.h.

## Progress32

typedef ProgressN<32> osl::progress::Progress32

Definition at line 43 of file progress.h.

## time_point

typedef std::chrono::time_point<clock> osl::misc::time_point

Definition at line 18 of file milliSeconds.h.

## Enumeration Type Documentation

## anonymous enum

anonymous enum

Enumerator
CheckOrEscapeMaxUniqMoves |

Definition at line 299 of file container.h.

## Direction

enum osl::Direction

Enumerator
SHORT_DIRECTION_MIN |
SHORT8_DIRECTION_MIN |
UL |
U |
UR |
L |
R |
DL |
D |
DR |
SHORT8_DIRECTION_MAX |
UUL |
UUR |
LONG_DIRECTION_MIN |
LONG_UL |
LONG_U |
LONG_UR |
LONG_L |
LONG_R |
LONG_DL |
LONG_D |
LONG_DR |
LONG_DIRECTION_MAX |
DIRECTION_MIN |
SHORT_DIRECTION_MAX |
SHORT_DIRECTION_SIZE |
DIRECTION_MAX |
DIRECTION_INVALID_VALUE |
DIRECTION_SIZE |

Definition at line 310 of file basic_type.h.

## Handicap

enum osl::Handicap

Enumerator
HIRATE |

Definition at line 20 of file simpleState.h.

## Move16

enum osl::Move16

16bit 表現

Enumerator
MOVE16_NONE |

Definition at line 1023 of file basic_type.h.

## MoveConstraint

enum osl::MoveConstraint

ある方向にある駒が移動可能かを表す.

(basicTypeだけは確定しているが，promote済みかどうかはわからない場合)

Enumerator
CannotMove | 可能でない
OnlyPromoted | promote済みの駒の場合にのみ可能
OnlyBasic | promoteしていない駒の場合にのみ可能
NoConstraint | promoteしていようが，いまいが可能

Definition at line 327 of file ptypeTraits.h.

## Player

enum osl::Player

Enumerator
BLACK |
WHITE |

Definition at line 8 of file basic_type.h.

## Ptype

enum osl::Ptype

駒の種類を4ビットでコード化する

Enumerator
PTYPE_EMPTY |
PTYPE_EDGE |
PPAWN |
PLANCE |
PKNIGHT |
PSILVER |
PBISHOP |
PROOK |
KING |
GOLD |
PAWN |
LANCE |
KNIGHT |
SILVER |
BISHOP |
ROOK |
PTYPE_MIN |
PTYPE_BASIC_MIN |
PTYPE_PIECE_MIN |
PTYPE_MAX |

Definition at line 83 of file basic_type.h.

## PtypeO

enum osl::PtypeO

Player + Ptype [-15, 15] PtypeO の O は Owner の O.

Enumerator
PTYPEO_MIN |
PTYPEO_MAX |

Definition at line 199 of file basic_type.h.

## Function Documentation

## __attribute__()

const PtypeO PTYPEO_EDGE osl::__attribute__ | ( | (unused) |  | ) |

References PTYPE_EDGE, and WHITE.

## alt() [1/2]

Player osl::alt | ( | Player | player | ) |

constexpr

Definition at line 13 of file basic_type.h.

Referenced by osl::checkmate::ProofPiecesUtil::addMonopolizedPieces(), osl::eval::ml::AttackMajorsInBase::addOne(), osl::eval::ml::MajorCheckWithCapture::addOne(), osl::move_probability::King5x5Ptype::addOne(), osl::move_probability::MoveInfo::adhocAdjustAttackCheckmateDefender(), osl::move_probability::MoveInfo::adhocAdjustBishopFork(), osl::move_probability::MoveInfo::adhocAdjustBreakThreatmate(), osl::move_probability::MoveInfo::adhocAdjustSlider(), osl::checkmate::ProofTreeDepthDfpn::andNode(), osl::checkmate::Dfpn::attack(), osl::progress::ml::NewProgress::attack5x5Value(), osl::progress::Effect5x3WithBonus::attackEffect3(), osl::checkmate::FixedDepthSolverExt::SetProofPieces::attackEstimation(), osl::checkmate::ProofNumberTable::attackEstimation(), osl::checkmate::LibertyEstimator::attackH(), osl::checkmate::PureLibertyEstimator::attackH(), osl::checkmate::attackProofCost(), osl::Square::back(), osl::rating::BadLance::basicMatch(), osl::move_probability::KingBlockade::blockAll(), osl::rating::DefenseKing8::blocking(), osl::checkmate::Dfpn::blockingSimulation(), osl::eval::ml::CanCheckNonPawnPieceStandCombination::canCheck(), osl::eval::ml::KnightCheck::canCheck(), osl::enter_king::EnterKing::canDeclareWin(), osl::enter_king::EnterKing::canDeclareWin(), osl::move_classifier::PawnDropCheckmate< P >::canEscape(), osl::eval::ml::GoldFeatures::canMoveToSide(), osl::checkmate::CheckmateIfCapture::cannotCapture(), osl::eval::ml::GoldFeatures::canRetreat(), osl::eval::ml::SilverFeatures::canRetreat(), osl::rating::Threatmate::captureForKnightCheck(), osl::Move::capturePtypeO(), osl::SimpleState::changeTurn(), osl::NumEffectState::checkShadow(), osl::move_probability::Feature::classifyEffect9(), osl::move_probability::StateInfo::clearOldCache(), osl::eval::See::computeValue(), osl::record::KisenUtils::convertMove(), osl::effect_util::ShadowEffect::count(), osl::rating::CountEffect2::count(), osl::rating::DefenseKing8::count(), osl::eval::ml::King25Effect::countEffectAndPieces(), osl::progress::Effect5x3WithBonus::countEffectPieces(), osl::checkmate::ProofNumberTable::countLiberty(), osl::checkmate::ProofNumberTable::countLiberty(), osl::mobility::countMobilityBoth(), osl::checkmate::King8Info::countMoveCandidate(), osl::move_probability::CoverFork::defending(), osl::checkmate::Dfpn::defense(), osl::checkmate::LibertyEstimator::defenseH(), osl::NumEffectState::doCaptureMove(), osl::NumEffectState::doUndoCaptureMove(), osl::move_action::NoEffectFilter< P, OrigAction >::dropMove(), osl::checkmate::CheckmateIfCapture::effectiveAttackCandidate0(), osl::eval::ml::King25EffectEach< 2 >::effectState(), osl::eval::ml::King8Effect::effectState(), osl::eval::ml::King8EffectAll::effectState(), osl::eval::ml::King25EffectEachBoth::effectStateIndex3(), osl::SimpleState::emulateHandPiece(), osl::NumEffectState::epilogueCapture(), osl::eval::ml::KnightFork::eval(), osl::eval::ml::KnightHead::eval(), osl::eval::ml::LanceEffectPieceKingRelative::eval(), osl::eval::ml::NumPiecesBetweenBishopAndKing::eval(), osl::eval::ml::BishopExchangeSilverKing::evalOne(), osl::eval::ml::BishopRookFork::evalOne(), osl::eval::ml::CheckShadowPtype::evalOne(), osl::eval::ml::King25Effect3::evalOne(), osl::eval::ml::King25EffectCountCombination::evalOne(), osl::eval::ml::KingMobility::evalOne(), osl::eval::ml::MajorGoldSilverAttacked< Opening >::evalOne(), osl::eval::ml::NonPawnAttackedPtypePair::evalOne(), osl::eval::ml::PinPtypeAll::evalOne(), osl::eval::ml::PromotedMinorPieces::evalOne(), osl::eval::ml::Promotion37::evalOne(), osl::eval::ml::SilverFeatures::evalOne(), osl::eval::ml::King25EmptyAbs< Opening >::evalWithUpdate(), osl::eval::ml::KingPieceRelativeNoSupport::evalWithUpdate(), osl::eval::ml::KnightFork::evalWithUpdate(), osl::eval::ml::PawnDropBoth::evalWithUpdate(), osl::eval::ml::PawnPtypeOPtypeO::evalWithUpdate(), osl::eval::ml::PieceEval::evalWithUpdate(), osl::eval::ml::PieceStandY::evalWithUpdate(), osl::eval::ml::PtypeY::evalWithUpdate(), osl::eval::ml::PtypeYY::evalWithUpdate(), osl::eval::ml::NonPawnAttacked::evalWithUpdateBang(), osl::eval::ml::NonPawnAttackedPtype::evalWithUpdateBang(), osl::eval::ml::PawnAdvanceAll::evalWithUpdateBang(), osl::eval::ml::PiecePairKing::evalWithUpdateBang(), osl::eval::ml::PtypeCount::evalWithUpdateBang(), osl::eval::ml::PtypeYPawnY::evalWithUpdateBang(), osl::progress::Effect5x3::expect(), osl::progress::Effect5x3WithBonus::expect(), osl::effect_util::SendOffSquare::find(), osl::rating::PatternBlock::find(), osl::move_probability::BlockLong::findAll(), osl::move_probability::StateInfo::findCheckmateDefender(), osl::checkmate::Dfpn::findDagSource(), osl::eval::ml::BishopRookFork::findDropInLine(), osl::eval::See::findEffectPieces(), osl::eval::See::findEffectPiecesAfterMove(), osl::rating::AttackKing8Group::findMatch(), osl::rating::BadLanceGroup::findMatch(), osl::rating::BlockGroup::findMatch(), osl::rating::PatternBlockGroup::findMatch(), osl::rating::PtypeAttackedGroup::findMatch(), osl::move_probability::StateInfo::findShortThreatmate(), osl::NumEffectState::findThreatenedPiece(), osl::move_probability::StateInfo::finishUpdate(), osl::checkmate::Dfpn::generateCheck(), osl::checkmate::Dfpn::generateEscape(), osl::move_generator::PieceOnBoard< Action, noCapturePromote >::generatePiece(), osl::move_generator::PieceOnBoard< Action, noCapturePromote >::generatePiecePtype(), osl::rating::FeatureSet::generateRating(), osl::checkmate::Dfpn::grandParentSimulation(), osl::checkmate::King8Info::hasEffectMask(), osl::effect_util::Neighboring8Direct::Table::hasEffectOrAdditional(), osl::checkmate::FixedDepthSolverExt::hasEscapeByMove(), osl::checkmate::Dfpn::hasEscapeMove(), osl::checkmate::King8Info::hasMoveCandidate(), osl::NumEffectState::inCheck(), osl::eval::ml::KingPieceRelative::index(), osl::eval::ml::LanceEffectPieceKingRelative::index(), osl::eval::ml::PtypeYY::index(), osl::rating::BigramAttack::index(), osl::rating::ImmediateAddSupport::index(), osl::rating::Open::index(), osl::rating::PinAttack::index(), osl::eval::ml::NonPawnAttackedPtypePair::index1(), osl::NumEffectState::inUnblockableCheck(), osl::eval::ml::KingXBlockedBase::isBlocked(), osl::rating::Threatmate::isCandidate(), osl::NumEffectState::isConsistent(), osl::RepetitionCounter::isConsistent(), osl::move_probability::BreakThreatmate::isDefendingKing8(), osl::checkmate::DualDfpn::isLosingState(), osl::move_classifier::DirectCheck< P >::isMember(), osl::move_classifier::OpenCheck< P >::isMember(), osl::move_classifier::PawnDropCheckmate< P >::isMember(), osl::move_classifier::KingOpenMove< P >::isMemberMain(), osl::checkmate::ProofPieces::leaf(), osl::checkmate::ProofNumberTable::libertyAfterAllDrop(), osl::checkmate::ProofNumberTable::libertyAfterAllMove(), osl::checkmate::ProofNumberTable::libertyAfterAllMove(), osl::checkmate::King8Info::make(), osl::checkmate::King8Info::make(), osl::checkmate::King8Info::make(), osl::rating::RatingEnv::make(), osl::rating::RatingEnv::make(), osl::record::CsaFile::makeInfo(), osl::NumEffectState::makeKing8Info(), osl::move_probability::BlockLong::makeLongAttackOne(), osl::rating::RelativeKingX::makeOldX(), osl::rating::RelativeKingY::makeOldY(), osl::NumEffectState::makePinOpen(), osl::progress::Effect5x3::makeProgressAll(), osl::checkmate::King8Info::makeWithPin(), osl::rating::RelativeKingX::makeX(), osl::rating::RelativeKingY::makeY(), osl::move_probability::AttackFromOpposingSliders::match(), osl::move_probability::CapturePtype::match(), osl::move_probability::CheckmateIfCapture::match(), osl::move_probability::CoverFork::match(), osl::move_probability::CoverPawn::match(), osl::move_probability::DropAfterOpposingPawn::match(), osl::move_probability::EscapeThreatened::match(), osl::move_probability::FromEffect::match(), osl::move_probability::FromEffectLong::match(), osl::move_probability::King5x5Ptype::match(), osl::move_probability::KingBlockade::match(), osl::move_probability::KingRelativeX::match(), osl::move_probability::KingRelativeY::match(), osl::move_probability::LanceAttack::match(), osl::move_probability::LongRecapture::match(), osl::move_probability::LureDefender::match(), osl::move_probability::LureDefender::match(), osl::move_probability::MoveFromOpposingSliders::match(), osl::move_probability::OpposingPawn::match(), osl::move_probability::PatternBase< false >::match(), osl::move_probability::PromotionBySacrifice::match(), osl::move_probability::RookAttack::match(), osl::move_probability::SacrificeAttack::match(), osl::move_probability::SeeFeature::match(), osl::move_probability::ToEffectLong::match(), osl::rating::AttackKing8::match(), osl::rating::BadLance::match(), osl::rating::Block::match(), osl::rating::CheckmateIfCapture::match(), osl::rating::PatternBlock::match(), osl::rating::PinAttack::match(), osl::rating::PtypeAttacked::match(), osl::rating::Karanari::matchGeneral(), osl::eval::ml::SilverFork::matchGold(), osl::move_probability::PawnAttack::matchPtype(), osl::eval::ml::SilverFork::matchRook(), osl::checkmate::King8Info::moveCandidateMask(), osl::move_probability::MoveInfo::MoveInfo(), osl::record::KisenFile::moves(), osl::hash::HashKey::newMakeMove(), osl::hash::HashKey::newUnmakeMove(), osl::effect_util::SendOffSquare::onlyOneSupport(), osl::eval::ml::King8EffectBase::MakeEffectStateDefense::operator()(), osl::eval::ml::King8EffectBase::MakeEffectStateSimple::operator()(), osl::rating::Threatmate::Helper::operator()(), osl::eval::ml::PinPtypeAll::pawnAttack(), osl::RepetitionCounter::pop(), osl::progress::ml::NewProgress::progress16(), osl::progress::ml::NewProgress::progressAttack(), osl::progress::ml::NewProgress::progressDefense(), osl::progress::ml::NewProgress::progressOne(), osl::NumEffectState::prologueCapture(), osl::NumEffectState::prologueDrop(), osl::NumEffectState::prologueSimple(), osl::progress::ml::NewProgress::promotion37One(), osl::checkmate::Dfpn::proofOracleAttack(), osl::checkmate::Dfpn::proofOracleDefense(), osl::RepetitionCounter::push(), osl::NumEffectState::recalcPinOpen(), osl::Move::rotate180(), osl::SimpleState::rotate180(), osl::checkmate::Dfpn::Node::setCheckmateDefense(), osl::checkmate::Dfpn::Node::setNoCheckmateAttack(), osl::checkmate::Dfpn::Node::setNoCheckmateDefense(), osl::SimpleState::setPieceAll(), osl::checkmate::DualDfpn::setRootPlayer(), osl::progress::Effect5x3Table::setupBlockEffect(), osl::progress::Effect5x3Table::setupLongEffect(), osl::progress::Effect5x3Table::setupShortEffect(), osl::move_probability::CheckFeature::sign(), osl::move_action::NoEffectFilter< P, OrigAction >::simpleMove(), osl::move_probability::ToEffect::supportAttack(), osl::move_probability::ToEffect::supportAttack(), osl::eval::ml::BishopRookFork::testCenter(), osl::move_action::NoEffectFilter< P, OrigAction >::unknownMove(), osl::eval::ml::OpenMidEndingEval::update(), osl::progress::Effect5x3::update(), osl::progress::ml::NewProgress::updateAttack5x5Pieces(), osl::progress::ml::NewProgress::updateAttack5x5PiecesAndState(), osl::move_probability::PatternCommon::updateCacheOne(), osl::eval::ml::NonPawnAttackedPtype::updateChanged(), osl::eval::ml::NonPawnAttacked::updateEffectChanged(), osl::progress::ml::NewProgress::updateMain(), osl::progress::ml::NewProgress::updateNonPawnAttackedPtypePairOne(), osl::progress::ml::NewProgress::updatePieceKingRelativeBonus(), osl::move_probability::StateInfo::updatePinnedGenerals(), osl::eval::ml::OpenMidEndingEval::updateSub(), osl::progress::ml::NewProgress::updateSub(), and osl::NumEffectState::wasCheckEvasion().

## alt() [2/2]

PtypeO osl::alt | ( | PtypeO | ptypeO | ) |

inline

owner を反転する

Definition at line 271 of file basic_type.h.

References isPiece().

## altIfPiece()

PtypeO osl::altIfPiece | ( | PtypeO | ptypeO | ) |

inline

Pieceの時にはowner を反転する

Definition at line 281 of file basic_type.h.

Referenced by osl::eval::ml::BishopStandFile5::eval(), osl::eval::ml::King3Pieces::index(), osl::eval::ml::PawnPtypeOPtypeO::index(), osl::eval::ml::BishopHead::indexX(), osl::eval::ml::King3Pieces::indexX(), osl::eval::ml::King3Pieces::indexY(), and osl::move_probability::PatternCommon::updateCacheOne().

## canPromote() [1/2]

bool osl::canPromote | ( | Ptype | ptype | ) |

inline

ptypeがpromote可能な型かどうかのチェック promote済みの場合はfalseを返す

Definition at line 147 of file basic_type.h.

References GOLD, and isPiece().

Referenced by canPromote(), osl::eval::See::computeValue(), osl::effect_action::AlwaysMove< Action >::doAction(), osl::effect_action::BetterToPromote< Action >::doAction(), osl::effect_action::AlwaysMove< Action >::doActionPtype(), osl::effect_action::BetterToPromote< Action >::doActionPtype(), osl::move_generator::PieceOnBoard< Action, noCapturePromote >::generatePiecePtypeUnsafe(), osl::move_generator::PieceOnBoard< Action, noCapturePromote >::generatePieceUnsafe(), osl::PtypeTable::initPtypeSub(), osl::Piece::isPlayerBasicPtype(), osl::SimpleState::isValidMoveByRule(), osl::move_probability::LureDefender::match(), osl::usi::parseBoard(), osl::Move::promote(), osl::Piece::promote(), promote(), promote(), osl::ki2::show(), and osl::psn::showXP().

## canPromote() [2/2]

bool osl::canPromote | ( | PtypeO | ptypeO | ) |

inline

Definition at line 287 of file basic_type.h.

References canPromote(), and getPtype().

## captured()

PtypeO osl::captured | ( | PtypeO | ptypeO | ) |

inline

unpromoteすると共に，ownerを反転する．

Definition at line 264 of file basic_type.h.

References isPiece().

Referenced by osl::checkmate::ProofPieces::attack(), osl::rating::Threatmate::captureForKnightCheck(), osl::eval::ml::OpenMidEndingEval::captureValue(), osl::record::KisenUtils::convertMove(), osl::checkmate::DisproofPieces::defense(), osl::checkmate::CheckmateIfCapture::effectiveAttackCandidate0(), osl::eval::ml::King25EmptyAbs< Opening >::evalWithUpdate(), osl::eval::ml::KingPieceRelative::evalWithUpdate(), osl::eval::ml::KingPieceRelativeNoSupport::evalWithUpdate(), osl::eval::ml::PawnDropBoth::evalWithUpdate(), osl::eval::ml::PawnPtypeOPtypeO::evalWithUpdate(), osl::eval::ml::PieceEval::evalWithUpdate(), osl::eval::ml::PieceStand::evalWithUpdate(), osl::eval::ml::PromotedMinorPieces::evalWithUpdate(), osl::eval::ml::PtypeX::evalWithUpdate(), osl::eval::ml::PtypeY::evalWithUpdate(), osl::eval::ml::PtypeYY::evalWithUpdate(), osl::eval::ml::NonPawnAttacked::evalWithUpdateBang(), osl::eval::ml::NonPawnAttackedPtype::evalWithUpdateBang(), osl::eval::ml::PawnAdvanceAll::evalWithUpdateBang(), osl::eval::ml::PiecePairKing::evalWithUpdateBang(), osl::eval::ml::PtypeCount::evalWithUpdateBang(), osl::eval::ml::PtypeYPawnY::evalWithUpdateBang(), osl::NumEffectState::makeMove(), osl::NumEffectState::makeUnmakeMove(), osl::move_probability::BreakThreatmate::match(), osl::move_probability::CapturePtype::match(), osl::move_probability::ThreatmateByCapture::match(), osl::move_probability::ToEffect::match(), osl::hash::HashKey::newMakeMove(), osl::hash::HashKey::newUnmakeMove(), osl::eval::PtypeEvalTable::reset(), osl::kakinoki::strToMove(), osl::psn::strToMove(), osl::move_action::NoAddEffectFilter< OrigAction >::unknownMove(), osl::move_action::NoEffectFilter< P, OrigAction >::unknownMove(), osl::move_action::NotKingOpenFilter< P, OrigAction >::unknownMove(), osl::move_action::Store::unknownMove(), osl::progress::ml::NewProgress::updateMain(), osl::eval::ml::OpenMidEndingEval::updateSub(), and osl::progress::ml::NewProgress::updateSub().

## dirToMask()

int osl::dirToMask | ( | Direction | dir | ) |

constexpr

Definition at line 393 of file basic_type.h.

Referenced by osl::effect::EffectedNumTable::EffectedNumTable(), osl::checkmate::ImmediateCheckmateTable::ImmediateCheckmateTable(), osl::checkmate::ProofNumberTable::init(), and osl::mobility::MobilityTable::MobilityTable().

## elapsedSeconds()

double osl::misc::elapsedSeconds | ( | time_point | start | ) |

inline

Definition at line 29 of file milliSeconds.h.

Referenced by osl::checkmate::DualDfpn::runGC().

## getOwner()

Player osl::getOwner | ( | PtypeO | ptypeO | ) |

inline

Definition at line 256 of file basic_type.h.

References isPiece().

Referenced by osl::eval::ml::PawnAdvanceUtil::cantAdvance(), osl::effect_util::Neighboring8Direct::Table::hasEffectOrAdditional(), osl::eval::ml::KingPieceRelative::index(), osl::move_probability::BlockLong::longAttackIndex(), operator<<(), osl::usi::parse(), osl::usi::parseBoard(), osl::record::KanjiPrint::print(), and osl::usi::show().

## getPtype()

Ptype osl::getPtype | ( | PtypeO | ptypeO | ) |

inline

Definition at line 217 of file basic_type.h.

Referenced by canPromote(), osl::eval::ml::PawnAdvanceUtil::cantAdvance(), osl::NumEffectState::epilogueCapture(), osl::effect_util::Neighboring8Direct::Table::findNearest(), osl::effect_util::Neighboring8Direct::Table::hasEffect(), osl::effect_util::Neighboring8Direct::hasEffectNaive(), osl::effect_util::Neighboring8Direct::Table::hasEffectOrAdditional(), osl::eval::ml::BishopEffectBase::index1(), osl::eval::ml::RookEffectBase::index1(), isPiece(), isPromoted(), osl::SimpleState::isValidMoveByRule(), osl::move_probability::BlockLong::longAttackIndex(), osl::Move::oldPtype(), operator<<(), osl::usi::parse(), osl::usi::parseBoard(), osl::NumEffectState::prologueCapture(), promote(), osl::eval::ml::BishopEffectPieceKingRelative::setUp(), osl::eval::ml::RookEffectPieceKingRelative::setUp(), and osl::usi::show().

## indexToPlayer()

Player osl::indexToPlayer | ( | int | n | ) |

constexpr

Definition at line 19 of file basic_type.h.

Referenced by osl::eval::ml::King8EffectBase::evalWithUpdateCommon(), osl::eval::ml::King8EffectBase::evalWithUpdateCommon(), osl::NumEffectState::isConsistent(), osl::NumEffectState::isConsistent(), osl::NumEffectState::NumEffectState(), osl::usi::show(), osl::book::MiniBoardChar50::toSimpleState(), and osl::progress::ml::NewProgress::updatePieceStand7().

## inverse()

Direction osl::inverse | ( | Direction | d | ) |

constexpr

Definition at line 358 of file basic_type.h.

References inverseUnsafe().

Referenced by osl::mobility::BishopMobility::countAllDir(), osl::eval::ml::NumPiecesBetweenBishopAndKing::countBetween(), osl::effect::EffectedNumTable::EffectedNumTable(), osl::eval::ml::BishopBishopPiece::eval(), osl::eval::ml::RookRookPiece::eval(), osl::NumEffectState::findLongAttackAt(), osl::BoardTable::getShort8(), osl::NumEffectState::kingMobilityOfPlayer(), osl::mobility::MobilityTable::MobilityTable(), and primDir().

## inverseUnsafe()

Direction osl::inverseUnsafe | ( | Direction | d | ) |

constexpr

Definition at line 354 of file basic_type.h.

Referenced by inverse(), osl::NumEffectState::pinAttacker(), and primDirUnsafe().

## isBasic()

bool osl::isBasic | ( | Ptype | ptype | ) |

inline

ptypeが基本型(promoteしていない)かのチェック

Definition at line 128 of file basic_type.h.

References isValid(), and PROOK.

Referenced by osl::PieceStand::add(), osl::ShouldPromoteCut::canIgnore(), osl::rating::ChaseGroup::ChaseGroup(), osl::SimpleState::countPiecesOnStand(), osl::rating::ChaseGroup::findMatch(), osl::PtypeTable::getIndexLimit(), osl::PtypeTable::getIndexMin(), osl::rating::DropPtype::index(), osl::Piece::isPlayerBasicPtype(), osl::SimpleState::isValidMoveByRule(), and osl::PieceStand::sub().

## isLong()

bool osl::isLong | ( | Direction | d | ) |

constexpr

Definition at line 350 of file basic_type.h.

References LONG_DIRECTION_MIN.

Referenced by osl::move_probability::AddEffectLong::addOne(), osl::effect_util::AdditionalOrShadow::count(), osl::checkmate::ProofNumberTable::countLibertyLong(), osl::effect_util::Neighboring8Direct::Table::init(), osl::PtypeTable::init(), and osl::NumEffectState::recalcPinOpen().

## isMajor()

bool osl::isMajor | ( | Ptype | ptype | ) |

inline

Definition at line 185 of file basic_type.h.

References isMajorBasic(), isPiece(), and unpromote().

Referenced by osl::checkmate::Dfpn::attack(), osl::enter_king::EnterKing::canDeclareWin(), osl::enter_king::EnterKing::canDeclareWin(), osl::checkmate::ProofNumberTable::countLibertyLong(), osl::eval::ml::PromotedMinorPieces::evalWithUpdate(), osl::move_probability::StateInfo::finishUpdate(), osl::checkmate::ProofNumberTable::libertyAfterAllMove(), and osl::ki2::show().

## isMajorBasic()

bool osl::isMajorBasic | ( | Ptype | ptype | ) |

inline

Definition at line 181 of file basic_type.h.

Referenced by isMajor(), and osl::eval::ml::OpenMidEndingEval::updateSub().

## isMajorNonPieceOK()

bool osl::isMajorNonPieceOK | ( | Ptype | ptype | ) |

inline

Definition at line 190 of file basic_type.h.

Referenced by osl::eval::ml::OpenMidEndingEval::updateSub().

## isPiece() [1/2]

bool osl::isPiece | ( | Ptype | ptype | ) |

constexpr

ptypeが空白やEDGEでないかのチェック

Definition at line 120 of file basic_type.h.

References PTYPE_PIECE_MIN.

Referenced by alt(), osl::checkmate::ProofPieces::attack(), canPromote(), captured(), osl::checkmate::DisproofPieces::defense(), osl::eval::ml::Promotion37::evalOne(), osl::rating::AttackKing8Group::findMatch(), osl::rating::PatternGroup::findMatch(), getOwner(), osl::checkmate::ProofNumberTable::init(), osl::effect_util::Neighboring8Direct::Table::init(), isMajor(), isPiece(), isPromoted(), osl::move_probability::BlockLong::makeLongAttackOne(), osl::move_probability::StateInfo::makePinOfLongPieces(), osl::rating::AttackKing8::match(), osl::rating::LongTarget2::match(), osl::rating::Pattern::match(), operator<<(), osl::kakinoki::KakinokiFile::parseLine(), osl::record::KanjiPrint::print(), promote(), promote(), osl::progress::ml::NewProgress::promotion37One(), osl::eval::PtypeEvalTable::reset(), osl::eval::ml::PiecePair::sanitize(), osl::csa::show(), osl::usi::show(), osl::psn::strToMove(), unpromote(), unpromoteSafe(), and osl::move_probability::PatternCommon::updateCacheOne().

## isPiece() [2/2]

bool osl::isPiece | ( | PtypeO | ptypeO | ) |

inline

EMPTY, EDGEではない

Definition at line 250 of file basic_type.h.

References getPtype(), isPiece(), and isValidPtypeO().

## isPromoted() [1/2]

bool osl::isPromoted | ( | Ptype | ptype | ) |

inline

ptypeがpromote後の型かどうかのチェック

Definition at line 137 of file basic_type.h.

References isPiece(), and KING.

Referenced by osl::checkmate::Dfpn::attack(), osl::eval::ml::Promotion37::evalOne(), osl::eval::ml::PromotedMinorPieces::evalWithUpdate(), osl::eval::ml::PiecePairKing::evalWithUpdateBang(), osl::NumEffectState::findAttackAtStrict(), osl::NumEffectState::forEachOnBoardPtypeStrict(), osl::PtypeTable::getCanDropLimit(), osl::NumEffectState::hasEffectByPtypeStrict(), osl::eval::ml::PtypeCount::indexBoardCount(), osl::eval::ml::PtypeCount::indexBoardCount(), osl::eval::ml::PtypeCount::indexBoardCountX(), osl::eval::ml::PtypeCount::indexBoardCountX(), osl::eval::ml::PtypeCount::indexBoardCountY(), osl::eval::ml::PtypeCount::indexBoardCountY(), osl::eval::ml::PtypeCount::indexCount(), osl::eval::ml::PtypeCount::indexCount(), osl::eval::ml::PtypeCount::indexCountX(), osl::eval::ml::PtypeCount::indexCountX(), osl::eval::ml::PtypeCount::indexCountY(), osl::eval::ml::PtypeCount::indexCountY(), osl::eval::ml::PiecePairKing::indexPiece(), isPromoted(), osl::SimpleState::isValidMoveByRule(), osl::checkmate::ProofNumberTable::libertyAfterAllMove(), osl::eval::PtypeEvalTable::promoteValue(), osl::progress::ml::NewProgress::promotion37One(), osl::ki2::show(), osl::usi::show(), osl::csa::strToMove(), and osl::Move::unpromote().

## isPromoted() [2/2]

bool osl::isPromoted | ( | PtypeO | ptypeO | ) |

inline

ptypeOが promote済みかどうか

Definition at line 296 of file basic_type.h.

References getPtype(), isPromoted(), and isValidPtypeO().

## isShort()

bool osl::isShort | ( | Direction | d | ) |

constexpr

Definition at line 342 of file basic_type.h.

References SHORT_DIRECTION_MAX.

## isShort8()

bool osl::isShort8 | ( | Direction | d | ) |

constexpr

Definition at line 346 of file basic_type.h.

References SHORT8_DIRECTION_MAX.

## isValid() [1/3]

bool osl::isValid | ( | Direction | d | ) |

Definition at line 93 of file basic_type.cc.

References DIRECTION_MAX, and DIRECTION_MIN.

## isValid() [2/3]

bool osl::isValid | ( | Player | player | ) |

cast等で作られたplayerが正しいかどうかを返す

Definition at line 9 of file basic_type.cc.

References BLACK, and WHITE.

Referenced by osl::eval::betterThan(), osl::eval::delta(), osl::PtypeTable::getCanDropLimit(), osl::PtypeTable::getKingIndex(), osl::BoardTable::getLongDirection(), isBasic(), osl::Piece::isOnBoard(), osl::Move::isValid(), osl::SimpleState::kingPiece(), osl::SimpleState::kingSquare(), osl::eval::max(), osl::eval::min(), osl::eval::notLessThan(), and osl::eval::PtypeEvalTable::value().

## isValid() [3/3]

bool osl::isValid | ( | Ptype | ptype | ) |

int等からcastして作ったptypeが，正しい範囲に入っているかどうかのチェック

Definition at line 24 of file basic_type.cc.

References PTYPE_MAX, and PTYPE_MIN.

## isValidPtypeO()

bool osl::isValidPtypeO | ( | int | ptypeO | ) |

Definition at line 30 of file basic_type.cc.

References PTYPEO_MAX, and PTYPEO_MIN.

Referenced by osl::hash::HashGenTable::addHashKey(), osl::eval::ml::OpenMidEndingEval::captureValue(), osl::eval::PtypeEvalTable::captureValue(), osl::PtypeTable::effect(), osl::PtypeTable::getEffect(), osl::PtypeTable::getEffectNotLongU(), isPiece(), isPromoted(), osl::hash::HashGenTable::subHashKey(), and osl::eval::PtypeEvalTable::value().

## longToShort()

Direction osl::longToShort | ( | Direction | d | ) |

constexpr

Definition at line 380 of file basic_type.h.

References LONG_UL.

Referenced by osl::move_probability::BlockLong::addPiece(), osl::effect_util::AdditionalOrShadow::count(), osl::effect::NumSimpleEffectTable::doEffectLong(), osl::effect_util::Neighboring8Direct::Table::hasEffectOrAdditional(), osl::NumEffectState::recalcPinOpen(), and osl::BoardTable::setDirections().

## msec()

template<class Duration>

long long osl::misc::msec | ( | Duration | duration | ) |

inline

Definition at line 26 of file milliSeconds.h.

## newOffset()

Offset osl::newOffset | ( | int | dx,
|  | int | dy )

inline

@obsolete

Definition at line 508 of file basic_type.h.

Referenced by osl::PtypeTable::init().

## newPtypeO()

PtypeO osl::newPtypeO | ( | Player | player,
|  | Ptype | ptype )

inline

Definition at line 211 of file basic_type.h.

Referenced by osl::eval::ml::MajorCheckWithCapture::addOne(), osl::rating::DefenseKing8::blocking(), osl::Move::capturePtypeO(), osl::usi::charToPtypeO(), osl::eval::See::computeValue(), osl::NumEffectState::doCaptureMove(), osl::NumEffectState::doSimpleMove(), osl::NumEffectState::doUndoCaptureMove(), osl::NumEffectState::doUndoSimpleMove(), osl::move_action::NoAddEffectFilter< OrigAction >::dropMove(), osl::NumEffectState::epilogueCapture(), osl::NumEffectState::epilogueSimple(), osl::eval::ml::PieceEval::evalWithUpdate(), osl::eval::ml::PtypeYY::evalWithUpdate(), osl::checkmate::ImmediateCheckmateTable::ImmediateCheckmateTable(), osl::effect_util::Neighboring8Direct::Table::init(), osl::effect_util::SendOffSquare::Table::init(), osl::progress::PtypeProgressTable::init(), osl::PtypeTable::init(), osl::rating::Threatmate::isCandidate(), osl::move_classifier::DirectCheck< P >::isMember(), osl::hash::HashKey::newMakeMove(), osl::hash::HashKey::newUnmakeMove(), osl::eval::ml::PiecePair::IndexTable::pindex(), osl::record::KanjiPrint::print(), osl::NumEffectState::prologueCapture(), osl::NumEffectState::prologueSimple(), osl::progress::PtypeProgress::PtypeProgress(), osl::PtypeTable::PtypeTable(), osl::eval::PtypeEvalTable::reset(), osl::eval::ml::PiecePair::sanitize(), osl::eval::ml::BishopHeadKingRelative::setUp(), osl::eval::ml::PieceEval::setUp(), osl::progress::Effect5x3Table::setupLongEffect(), osl::progress::Effect5x3Table::setupShortEffect(), osl::usi::show(), osl::move_action::NoAddEffectFilter< OrigAction >::simpleMove(), and osl::move_action::NoAddEffectFilter< OrigAction >::unknownMove().

## operator!=() [1/9]

bool osl::operator!= | ( | const NumEffectState & | s1,
|  | const NumEffectState & | s2 )

inline

Definition at line 1034 of file numEffectState.h.

## operator!=() [2/9]

bool osl::operator!= | ( | const PathEncoding & | l,
|  | const PathEncoding & | r )

inline

Definition at line 77 of file pathEncoding.h.

## operator!=() [3/9]

bool osl::operator!= | ( | const PieceMask & | m1,
|  | const PieceMask & | m2 )

inline

Definition at line 101 of file pieceMask.h.

## operator!=() [4/9]

bool osl::operator!= | ( | EffectContent | l,
|  | EffectContent | r )

inline

Definition at line 58 of file effectContent.h.

## operator!=() [5/9]

bool osl::operator!= | ( | Move | lhs,
|  | Move | rhs )

inline

Definition at line 1344 of file basic_type.h.

## operator!=() [6/9]

bool osl::operator!= | ( | Offset | l,
|  | Offset | r )

inline

Definition at line 516 of file basic_type.h.

## operator!=() [7/9]

bool osl::operator!= | ( | Piece | l,
|  | Piece | r )

inline

Definition at line 999 of file basic_type.h.

## operator!=() [8/9]

bool osl::operator!= | ( | PieceStand | l,
|  | PieceStand | r )

inline

Definition at line 258 of file bits/pieceStand.h.

## operator!=() [9/9]

bool osl::operator!= | ( | Square | l,
|  | Square | r )

inline

Definition at line 762 of file basic_type.h.

## operator&()

const PieceMask osl::operator& | ( | const PieceMask & | m1,
|  | const PieceMask & | m2 )

inline

Definition at line 88 of file pieceMask.h.

References osl::PieceMask::getMask().

## operator*() [1/2]

int osl::operator* | ( | int | ,
|  | Player | )

## operator*() [2/2]

int osl::operator* | ( | Player | ,
|  | int | )

## operator+() [1/2]

int osl::operator+ | ( | int | ,
|  | Player | )

## operator+() [2/2]

int osl::operator+ | ( | Player | ,
|  | int | )

## operator-() [1/2]

int osl::operator- | ( | int | ,
|  | Player | )

## operator-() [2/2]

int osl::operator- | ( | Player | ,
|  | int | )

## operator/() [1/2]

int osl::operator/ | ( | int | ,
|  | Player | )

## operator/() [2/2]

int osl::operator/ | ( | Player | ,
|  | int | )

References BLACK, and WHITE.

## operator<() [1/9]

template<typename T, size_t C>

bool osl::operator< | ( | const FixedCapacityVector< T, C > & | l,
|  | const FixedCapacityVector< T, C > & | r )

inline

Definition at line 273 of file container.h.

References osl::FixedCapacityVector< T, Capacity >::begin(), and osl::FixedCapacityVector< T, Capacity >::end().

## operator<() [2/9]

bool osl::operator< | ( | const MoveVector & | l,
|  | const MoveVector & | r )

Definition at line 13 of file container.cc.

References osl::FixedCapacityVector< T, Capacity >::begin(), and osl::FixedCapacityVector< T, Capacity >::end().

## operator<() [3/9]

bool osl::operator< | ( | EffectContent | l,
|  | EffectContent | r )

inline

Definition at line 62 of file effectContent.h.

References osl::EffectContent::intValue().

## operator<() [4/9]

bool osl::operator< | ( | Move | lhs,
|  | Move | rhs )

inline

Definition at line 1328 of file basic_type.h.

References osl::Move::intValue().

## operator<() [5/9]

bool osl::operator< | ( | MoveLogProb const & | lhs,
|  | MoveLogProb const & | rhs )

inline

Definition at line 53 of file moveLogProb.h.

References osl::MoveLogProb::logProb(), and osl::MoveLogProb::move().

## operator<() [6/9]

bool osl::operator< | ( | Offset | l,
|  | Offset | r )

inline

Definition at line 520 of file basic_type.h.

References osl::Offset::intValue().

## operator<() [7/9]

bool osl::operator< | ( | Piece | l,
|  | Piece | r )

inline

Definition at line 991 of file basic_type.h.

References osl::Piece::intValue().

## operator<() [8/9]

bool osl::operator< | ( | PieceStand | l,
|  | PieceStand | r )

inline

Definition at line 262 of file bits/pieceStand.h.

References osl::PieceStand::getFlags(), and osl::PieceStand::testCarries().

## operator<() [9/9]

bool osl::operator< | ( | Square | l,
|  | Square | r )

inline

Definition at line 766 of file basic_type.h.

References osl::Square::uintValue().

## operator<<() [1/16]

std::ostream & osl::operator<< | ( | std::ostream & | os,
|  | const PathEncoding & | path )

Definition at line 38 of file pathEncoding.cc.

References osl::PathEncoding::getDepth(), and osl::PathEncoding::getPath().

## operator<<() [2/16]

std::ostream & osl::operator<< | ( | std::ostream & | os,
|  | const Sennichite & | s )

Definition at line 16 of file sennichite.cc.

References osl::Sennichite::isDraw(), osl::Sennichite::isNormal(), and osl::Sennichite::winner().

## operator<<() [3/16]

std::ostream & osl::operator<< | ( | std::ostream & | os,
|  | Offset | offset )

Definition at line 168 of file basic_type.cc.

References osl::Offset::intValue().

## operator<<() [4/16]

std::ostream & osl::operator<< | ( | std::ostream & | os,
|  | osl::PieceStand | stand )

Definition at line 77 of file pieceStand.cc.

References osl::PieceStand::get(), and osl::PieceStand::order.

## operator<<() [5/16]

std::ostream & osl::operator<< | ( | std::ostream & | os,
|  | Square | square )

Definition at line 207 of file basic_type.cc.

References osl::Square::isPieceStand(), osl::Square::x(), and osl::Square::y().

## operator<<() [6/16]

std::ostream & osl::operator<< | ( | std::ostream & | os,
|  | const Direction | d )

Definition at line 97 of file basic_type.cc.

## operator<<() [7/16]

std::ostream & osl::operator<< | ( | std::ostream & | os,
|  | const Piece | piece )

Definition at line 216 of file basic_type.cc.

References osl::Piece::EDGE(), osl::Piece::EMPTY(), osl::Piece::isPiece(), osl::Piece::number(), osl::Piece::owner(), osl::Piece::ptype(), and osl::Piece::square().

## operator<<() [8/16]

std::ostream & osl::operator<< | ( | std::ostream & | os,
|  | const PieceVector & | pv )

Definition at line 52 of file container.cc.

## operator<<() [9/16]

std::ostream & osl::operator<< | ( | std::ostream & | os,
|  | const Ptype | ptype )

Definition at line 78 of file basic_type.cc.

References Ptype_Table.

## operator<<() [10/16]

std::ostream & osl::operator<< | ( | std::ostream & | os,
|  | const PtypeO | ptypeO )

Definition at line 83 of file basic_type.cc.

References getOwner(), getPtype(), and isPiece().

## operator<<() [11/16]

std::ostream & osl::operator<< | ( | std::ostream & | os,
|  | const SimpleState & | state )

Definition at line 570 of file simpleState.cc.

References BLACK, osl::SimpleState::pieceOnBoard(), osl::csa::show(), osl::SimpleState::turn(), and WHITE.

## operator<<() [12/16]

std::ostream & osl::operator<< | ( | std::ostream & | os,
|  | Move | move )

Definition at line 272 of file basic_type.cc.

References osl::Move::capturePtype(), osl::Move::DeclareWin(), osl::Move::from(), osl::Move::isInvalid(), osl::Move::isPass(), osl::Square::isPieceStand(), osl::Move::isValid(), osl::Move::oldPtypeO(), osl::Move::player(), osl::Move::promoteMask(), osl::Move::ptype(), PTYPE_EMPTY, osl::Move::ptypeO(), and osl::Move::to().

## operator<<() [13/16]

std::ostream & osl::operator<< | ( | std::ostream & | os,
|  | MoveLogProb const & | moveLogProb )

Definition at line 7 of file moveLogProb.cc.

References osl::MoveLogProb::logProb(), and osl::MoveLogProb::move().

## operator<<() [14/16]

std::ostream & osl::operator<< | ( | std::ostream & | os,
|  | MoveVector const & | mv )

Definition at line 5 of file container.cc.

## operator<<() [15/16]

std::ostream & osl::operator<< | ( | std::ostream & | os,
|  | PieceMask const & | pieceMask )

Definition at line 9 of file pieceMask.cc.

References osl::PieceMask::getMask(), and osl::misc::GeneralMask< Integer >::value().

## operator<<() [16/16]

std::ostream & osl::operator<< | ( | std::ostream & | os,
|  | Player | player )

Definition at line 14 of file basic_type.cc.

References BLACK.

## operator==() [1/13]

template<typename T, size_t C>

bool osl::operator== | ( | const FixedCapacityVector< T, C > & | l,
|  | const FixedCapacityVector< T, C > & | r )

inline

Definition at line 268 of file container.h.

References osl::FixedCapacityVector< T, Capacity >::begin(), osl::FixedCapacityVector< T, Capacity >::end(), and osl::FixedCapacityVector< T, Capacity >::size().

## operator==() [2/13]

bool osl::operator== | ( | const NumEffectState & | st1,
|  | const NumEffectState & | st2 )

駒番に依存した局面（インスタンス）比較をする.

なお、駒番に非依存な局面比較をしたい場合は、osl::record::CompactBoardや osl::hash::HashKeyを用いる.

Definition at line 22 of file numEffectState.cc.

References osl::NumEffectState::effects, osl::NumEffectState::isConsistent(), osl::NumEffectState::king8infos, osl::NumEffectState::king_mobility, osl::NumEffectState::pieces_onboard, osl::NumEffectState::pin_or_open, and osl::NumEffectState::promoted.

## operator==() [3/13]

bool osl::operator== | ( | const PathEncoding & | l,
|  | const PathEncoding & | r )

inline

Definition at line 73 of file pathEncoding.h.

References osl::PathEncoding::getPath().

## operator==() [4/13]

bool osl::operator== | ( | const PieceMask & | m1,
|  | const PieceMask & | m2 )

inline

Definition at line 98 of file pieceMask.h.

References osl::PieceMask::getMask().

## operator==() [5/13]

bool osl::operator== | ( | const Sennichite & | l,
|  | const Sennichite & | r )

inline

Definition at line 35 of file sennichite.h.

## operator==() [6/13]

bool osl::operator== | ( | const SimpleState & | st1,
|  | const SimpleState & | st2 )

盤上の駒のみを比較する（持ち駒は見ない）.

なお、駒番に非依存な局面比較をしたい場合は、osl::record::CompactBoardや osl::hash::HashKeyを用いる.

Definition at line 531 of file simpleState.cc.

References osl::SimpleState::isConsistent(), osl::SimpleState::pawnMask, osl::SimpleState::pieceAt(), osl::Piece::ptypeO(), and osl::SimpleState::turn().

## operator==() [7/13]

bool osl::operator== | ( | EffectContent | l,
|  | EffectContent | r )

inline

Definition at line 54 of file effectContent.h.

References osl::EffectContent::intValue().

## operator==() [8/13]

bool osl::operator== | ( | Move | lhs,
|  | Move | rhs )

inline

Definition at line 1340 of file basic_type.h.

References osl::Move::intValue().

## operator==() [9/13]

bool osl::operator== | ( | MoveLogProb const & | lhs,
|  | MoveLogProb const & | rhs )

inline

Definition at line 49 of file moveLogProb.h.

References osl::MoveLogProb::logProb(), and osl::MoveLogProb::move().

## operator==() [10/13]

bool osl::operator== | ( | Offset | l,
|  | Offset | r )

inline

Definition at line 512 of file basic_type.h.

References osl::Offset::intValue().

## operator==() [11/13]

bool osl::operator== | ( | Piece | l,
|  | Piece | r )

inline

Definition at line 995 of file basic_type.h.

References osl::Piece::intValue().

## operator==() [12/13]

bool osl::operator== | ( | PieceStand | l,
|  | PieceStand | r )

inline

Definition at line 252 of file bits/pieceStand.h.

References osl::PieceStand::getFlags(), and osl::PieceStand::testCarries().

## operator==() [13/13]

bool osl::operator== | ( | Square | l,
|  | Square | r )

inline

Definition at line 758 of file basic_type.h.

References osl::Square::uintValue().

## operator>()

bool osl::operator> | ( | Square | l,
|  | Square | r )

inline

Definition at line 770 of file basic_type.h.

References osl::Square::uintValue().

## operator>>()

std::istream & osl::operator>> | ( | std::istream & | is,
|  | osl::Ptype & | ptype )

Definition at line 35 of file basic_type.cc.

References BISHOP, GOLD, KING, KNIGHT, LANCE, PAWN, PBISHOP, PKNIGHT, PLANCE, PPAWN, PROOK, PSILVER, PTYPE_EDGE, PTYPE_EMPTY, ROOK, and SILVER.

## operator|()

const PieceMask osl::operator| | ( | const PieceMask & | m1,
|  | const PieceMask & | m2 )

inline

Definition at line 91 of file pieceMask.h.

References osl::PieceMask::getMask().

## operator~()

const PieceMask osl::operator~ | ( | const PieceMask & | m1 | ) |

inline

Definition at line 94 of file pieceMask.h.

References osl::PieceMask::getMask().

## playerToIndex()

int osl::playerToIndex | ( | Player | player | ) |

constexpr

Definition at line 16 of file basic_type.h.

Referenced by osl::effect::NumSimpleEffectTable::effectedChanged(), osl::effect::NumSimpleEffectTable::effectedMask(), osl::eval::ml::KingXBlockedBase::eval(), osl::eval::ml::KingXBlockedYBase::eval(), osl::eval::ml::KnightFork::evalOne(), osl::eval::ml::PtypeCount::evalPlayerPtype(), osl::eval::ml::PawnDropBoth::evalWithUpdate(), osl::progress::Effect5x3WithBonus::expect(), osl::rating::PatternGroup::findMatch(), osl::PtypeTable::getCanDropLimit(), osl::PtypeTable::getShortMoveMask(), osl::SimpleState::isConsistent(), osl::hash::HashKey128::isPlayerOfTurn(), osl::book::MiniBoardChar50::MiniBoardChar50(), osl::CArray< Move, 8 >::operator[](), osl::CArray< Move, 8 >::operator[](), osl::rating::PatternGroup::PatternGroup(), osl::progress::ml::NewProgress::progress16(), osl::SimpleState::setPiece(), osl::SimpleState::setPieceAll(), and osl::hash::HashKey128::setPlayer().

## playerToMask()

int osl::playerToMask | ( | Player | player | ) |

constexpr

Definition at line 28 of file basic_type.h.

## primDir()

Direction osl::primDir | ( | Direction | d | ) |

constexpr

8方向について，primitiveな4方向を求める

Definition at line 366 of file basic_type.h.

References inverse().

Referenced by osl::move_generator::PieceOnBoard< Action, noCapturePromote >::generatePiece(), osl::move_generator::PieceOnBoard< Action, noCapturePromote >::generatePiecePtype(), osl::NumEffectState::pinnedCanMoveTo(), and osl::NumEffectState::wasCheckEvasion().

## primDirUnsafe()

Direction osl::primDirUnsafe | ( | Direction | d | ) |

constexpr

8方向について，primitiveな4方向を求める dとしてknight, INVALIDなども来る

Definition at line 374 of file basic_type.h.

References inverseUnsafe().

Referenced by osl::move_generator::PieceOnBoard< Action, noCapturePromote >::generatePiece(), osl::move_generator::PieceOnBoard< Action, noCapturePromote >::generatePiecePtype(), osl::NumEffectState::pinnedCanMoveTo(), and osl::NumEffectState::wasCheckEvasion().

## promote() [1/2]

Ptype osl::promote | ( | Ptype | ptype | ) |

inline

promote可能なptypeに対して，promote後の型を返す promote不可のptypeを与えてはいけない．

Definition at line 173 of file basic_type.h.

References canPromote(), and isPiece().

Referenced by osl::eval::See::computeValue(), osl::record::KisenUtils::convertMove(), osl::effect_action::AlwaysMove< Action >::doAction(), osl::effect_action::BetterToPromote< Action >::doAction(), osl::effect_action::AlwaysMove< Action >::doActionPtype(), osl::effect_action::BetterToPromote< Action >::doActionPtype(), osl::Move::fromMove16(), osl::move_generator::PieceOnBoard< Action, noCapturePromote >::generatePiecePtypeUnsafe(), osl::move_generator::PieceOnBoard< Action, noCapturePromote >::generatePieceUnsafe(), osl::book::MiniBoard::getState(), osl::PtypeTable::initPtypeSub(), osl::Piece::isPlayerBasicPtype(), osl::record::KisenPlusFile::load(), osl::move_probability::LureDefender::match(), osl::usi::parseBoard(), osl::ki2::showPromote(), osl::kakinoki::strToMove(), osl::psn::strToMove(), and osl::book::MiniBoardChar50::toSimpleState().

## promote() [2/2]

PtypeO osl::promote | ( | PtypeO | ptypeO | ) |

inline

pieceをpromoteさせる.

promote不可のptypeを与えてはいけない．

Definition at line 223 of file basic_type.h.

References canPromote(), getPtype(), and isPiece().

## promoteWithMask()

PtypeO osl::promoteWithMask | ( | PtypeO | ptypeO,
|  | int | promoteMask )

inline

pieceを引数次第でpromoteさせる

Definition at line 232 of file basic_type.h.

## ptypeOIndex()

unsigned int osl::ptypeOIndex | ( | PtypeO | ptypeo | ) |

inline

Definition at line 205 of file basic_type.h.

References PTYPEO_MIN.

Referenced by osl::move_probability::PatternCommon::addOne(), osl::eval::ml::PiecePair::adjust12(), osl::eval::ml::BishopStandFile5::eval(), osl::eval::ml::PiecePair::evalWithUpdateCompiled(), osl::effect_util::Neighboring8Direct::Table::findNearest(), osl::effect_util::Neighboring8Direct::Table::hasEffect(), osl::effect_util::Neighboring8Direct::Table::hasEffectOrAdditional(), osl::eval::ml::King3Pieces::index(), osl::eval::ml::PiecePair::index(), osl::eval::ml::BishopHead::indexK(), osl::eval::ml::BishopHead::indexX(), osl::eval::ml::King3Pieces::indexX(), osl::eval::ml::King3Pieces::indexY(), osl::effect_util::Neighboring8Direct::Table::init(), osl::move_probability::BlockLong::makeLongAttackOne(), osl::move_probability::BreakThreatmate::match(), osl::CArray< Move, 8 >::operator[](), osl::CArray< Move, 8 >::operator[](), osl::eval::ml::PiecePair::IndexTable::pindex(), osl::eval::ml::BishopHeadKingRelative::setUp(), osl::progress::Effect5x3Table::setupLongEffect(), osl::progress::Effect5x3Table::setupShortEffect(), osl::eval::ml::PiecePair::sum12(), osl::move_probability::PatternCommon::updateCacheOne(), and osl::eval::ml::PiecePair::valueCompiled().

## random()

unsigned int osl::misc::random | ( |  | ) |

Definition at line 7 of file random.cc.

Referenced by osl::PathEncodingTable::init(), osl::eval::ml::MultiWeights::setRandom(), and osl::eval::ml::Weights::setRandom().

## shortToLong()

Direction osl::shortToLong | ( | Direction | d | ) |

constexpr

引数に longDirを与えてはいけない

Definition at line 388 of file basic_type.h.

References LONG_UL.

Referenced by osl::effect::EffectedNumTable::EffectedNumTable(), osl::checkmate::ImmediateCheckmateTable::ImmediateCheckmateTable(), osl::checkmate::ProofNumberTable::init(), and osl::mobility::MobilityTable::MobilityTable().

## sign()

int osl::sign | ( | Player | player | ) |

constexpr

Definition at line 23 of file basic_type.h.

Referenced by osl::eval::ml::BishopExchangeSilverKing::evalOne(), osl::eval::ml::EnterKingDefense::evalOne(), osl::eval::ml::KnightFork::evalOne(), osl::eval::ml::Promotion37::evalOne(), osl::BoardTable::getOffset(), osl::rating::Threatmate::knight2Step(), osl::rating::RookDefense::match(), osl::eval::ml::SilverFork::matchGold(), osl::eval::ml::SilverFork::matchRook(), osl::progress::ml::NewProgress::promotion37One(), osl::ki2::show(), and osl::move_probability::CheckFeature::sign().

## time_seeded_random()

unsigned int osl::misc::time_seeded_random | ( |  | ) |

Definition at line 8 of file random.cc.

## toSeconds()

template<class Duration>

double osl::misc::toSeconds | ( | Duration | duration | ) |

inline

Definition at line 22 of file milliSeconds.h.

## unpromote() [1/2]

Ptype osl::unpromote | ( | Ptype | ptype | ) |

inline

ptypeがpromote後の型の時に，promote前の型を返す． promoteしていない型の時はそのまま返す

Definition at line 157 of file basic_type.h.

References isPiece().

Referenced by osl::move_probability::MoveInfo::adhocAdjustBishopFork(), osl::checkmate::Dfpn::attack(), osl::checkmate::OracleAdjust::attack(), osl::checkmate::ProofPieces::attack(), osl::checkmate::LibertyEstimator::attackH(), osl::rating::Threatmate::captureForKnightCheck(), osl::checkmate::ProofNumberTable::countLibertyLong(), osl::checkmate::DisproofPieces::defense(), osl::effect_action::AlwaysMove< Action >::doActionPtype(), osl::effect_action::BetterToPromote< Action >::doActionPtype(), osl::checkmate::CheckmateIfCapture::effectiveAttackCandidate0(), osl::SimpleState::emulateCapture(), osl::NumEffectState::epilogueCapture(), osl::eval::ml::PawnDropBoth::evalWithUpdate(), osl::eval::ml::PieceEval::evalWithUpdate(), osl::eval::ml::PieceStand::evalWithUpdate(), osl::eval::ml::PieceStandY::evalWithUpdate(), osl::eval::ml::NonPawnPieceStandTurn::evalWithUpdateBang(), osl::eval::ml::PtypeCount::evalWithUpdateBang(), osl::rating::DropCapturedGroup::findMatchWithoutProgress(), osl::move_probability::StateInfo::finishUpdate(), osl::GenerateEscapeKing::generate(), osl::checkmate::Dfpn::generateCheck(), osl::PtypeTable::hasLongMove(), osl::eval::ml::PtypeCount::indexBoardCount(), osl::eval::ml::PtypeCount::indexBoardCountX(), osl::eval::ml::PtypeCount::indexBoardCountY(), osl::eval::ml::PtypeCount::indexCount(), osl::eval::ml::PtypeCount::indexCountX(), osl::eval::ml::PtypeCount::indexCountY(), osl::SimpleState::isConsistent(), isMajor(), osl::eval::ml::KnightFork::isTarget(), osl::SimpleState::isValidMoveByRule(), osl::rating::PatternLongGroup2::makeDirection(), osl::rating::PatternLongGroup::makeDirection(), osl::move_probability::BishopAttack::match(), osl::move_probability::CapturePtype::match(), osl::move_probability::RookAttack::match(), osl::rating::DropCaptured::match(), osl::book::MiniBoard::MiniBoard(), osl::book::MiniBoardChar50::MiniBoardChar50(), osl::PieceStand::nextStand(), osl::PieceBasicLessThan::operator()(), osl::rating::PatternLong::PatternLong(), osl::rating::PatternLong2::PatternLong2(), osl::PieceStand::previousStand(), osl::NumEffectState::prologueCapture(), osl::eval::PtypeEvalTable::reset(), osl::SimpleState::setPiece(), osl::progress::Effect5x3Table::setupOnStand(), osl::csa::show(), osl::ki2::show(), osl::usi::show(), osl::csa::strToMove(), unpromoteSafe(), osl::progress::ml::NewProgress::updateMain(), osl::progress::Effect5x3::updateStand(), and osl::eval::ml::OpenMidEndingEval::updateSub().

## unpromote() [2/2]

PtypeO osl::unpromote | ( | PtypeO | ptypeO | ) |

inline

pieceをunpromoteさせる.

promoteしていないptypeを与えてもよい

Definition at line 240 of file basic_type.h.

## unpromoteSafe()

Ptype osl::unpromoteSafe | ( | Ptype | ptype | ) |

constexpr

Definition at line 164 of file basic_type.h.

References isPiece(), and unpromote().

Referenced by osl::eval::ml::AttackMajorsInBase::index().

## Variable Documentation

## Board_Mask_Table3x3

const container::BoardMaskTable3x3 osl::container::Board_Mask_Table3x3

Definition at line 125 of file tables.cc.

Referenced by osl::eval::ml::KingXBlockedYBase::evalWithUpdateBang(), osl::eval::ml::King8EffectBase::evalWithUpdateCommon(), osl::eval::ml::King8EffectBase::evalWithUpdateCommon(), osl::NumEffectState::prologueCapture(), osl::NumEffectState::prologueDrop(), and osl::NumEffectState::prologueSimple().

## Board_Mask_Table5x3_Center

const container::BoardMaskTable5x3Center osl::container::Board_Mask_Table5x3_Center

Definition at line 135 of file tables.cc.

Referenced by osl::progress::Effect5x3::update(), osl::progress::Effect5x3d::update(), osl::progress::Effect5x3WithBonus::update(), and osl::progress::ml::NewProgress::updateMain().

## Board_Mask_Table5x5

const container::BoardMaskTable5x5 osl::container::Board_Mask_Table5x5

Definition at line 115 of file tables.cc.

Referenced by osl::eval::ml::King25EffectEachBoth::evalWithUpdate(), osl::eval::ml::King25EmptySquareNoEffect::evalWithUpdate(), osl::eval::ml::OpenMidEndingEval::updateSub(), and osl::progress::ml::NewProgress::updateSub().

## Board_Table

const BoardTable osl::Board_Table

Definition at line 95 of file tables.cc.

Referenced by osl::move_probability::AddEffectLong::addOne(), osl::move_probability::BlockLong::addPiece(), osl::checkmate::OracleAdjust::attack(), osl::Square::back(), osl::move_probability::KingBlockade::blockAll(), osl::move_classifier::PawnDropCheckmate< P >::canEscape(), osl::eval::ml::PawnAdvanceUtil::cantAdvance(), osl::rating::Threatmate::captureForKnightCheck(), osl::move_probability::StateInfo::clearOldCache(), osl::effect_util::AdditionalOrShadow::count(), osl::eval::ml::NumPiecesBetweenBishopAndKing::countBetween(), osl::checkmate::ProofNumberTable::countLibertyLong(), osl::checkmate::ProofNumberTable::countLibertyShortNotKnight(), osl::move_probability::CoverFork::defending(), osl::effect::NumSimpleEffectTable::doBlockAt(), osl::effect::EffectedNumTable::EffectedNumTable(), osl::checkmate::CheckmateIfCapture::effectiveAttackCandidate0(), osl::eval::ml::King8Effect::effectState(), osl::eval::ml::King8EffectAll::effectState(), osl::eval::ml::KnightHead::eval(), osl::eval::ml::PawnPtypeOPtypeO::eval(), osl::effect_util::AdditionalEffect::find(), osl::rating::PatternBlock::find(), osl::rating::PatternLong2::find(), osl::eval::See::findAdditionalPieces(), osl::move_probability::StateInfo::findCheckmateDefender(), osl::eval::ml::BishopRookFork::findDropInLine(), osl::rating::BadLanceGroup::findMatch(), osl::move_generator::PieceOnBoard< Action, noCapturePromote >::generatePiece(), osl::move_generator::PieceOnBoard< Action, noCapturePromote >::generatePiecePtype(), osl::effect_util::AdditionalEffect::hasEffect(), osl::effect_util::Neighboring8Direct::hasEffectFromTo(), osl::NumEffectState::hasEffectIf(), osl::NumEffectState::hasEffectInDirection(), osl::effect_util::Neighboring8Direct::Table::hasEffectOrAdditional(), osl::checkmate::ImmediateCheckmateTable::ImmediateCheckmateTable(), osl::checkmate::EdgeTable::init(), osl::effect_util::Neighboring8Direct::Table::init(), osl::PtypeTable::init(), osl::SimpleState::isEmptyBetween(), osl::SimpleState::isEmptyBetween(), osl::move_classifier::KingOpenMove< P >::isMember(), osl::move_classifier::KingOpenMove< P >::isMemberMain(), osl::Square::isNeighboring8(), osl::checkmate::ProofNumberTable::libertyAfterAllMove(), osl::checkmate::King8Info::make(), osl::move_probability::BlockLong::makeLongAttackOne(), osl::move_probability::CoverPawn::match(), osl::move_probability::DropAfterOpposingPawn::match(), osl::move_probability::KingBlockade::match(), osl::move_probability::LanceAttack::match(), osl::move_probability::LureDefender::match(), osl::move_probability::OpposingPawn::match(), osl::move_probability::PromotionBySacrifice::match(), osl::rating::BadLance::match(), osl::eval::ml::SilverFork::matchGold(), osl::eval::ml::SilverFork::matchRook(), osl::mobility::MobilityTable::MobilityTable(), osl::Square::neighbor(), osl::rating::PatternLong::nextPieceOrEnd(), osl::rating::Pattern::nextSquare(), osl::Offset::Offset(), osl::eval::ml::King8EffectBase::MakeEffectStateDefense::operator()(), osl::eval::ml::King8EffectBase::MakeEffectStateSimple::operator()(), osl::NumEffectState::pinnedCanMoveTo(), osl::NumEffectState::pinnedDir(), osl::NumEffectState::recalcPinOpen(), osl::move_probability::StateInfo::updatePinnedGenerals(), and osl::NumEffectState::wasCheckEvasion().

## DirectionPlayerTraits< Dir, BLACK >::directionByBlack

template<Direction Dir>

const Direction osl::DirectionPlayerTraits< Dir, BLACK >::directionByBlack

Definition at line 252 of file directionTraits.h.

## DirectionPlayerTraits< Dir, WHITE >::directionByBlack

template<Direction Dir>

const Direction osl::DirectionPlayerTraits< Dir, WHITE >::directionByBlack

Definition at line 262 of file directionTraits.h.

## EDGE_NUM

const int osl::EDGE_NUM =0x40

Definition at line 779 of file basic_type.h.

Referenced by osl::Piece::EDGE().

## EMPTY_NUM

const int osl::EMPTY_NUM =0x80

Definition at line 778 of file basic_type.h.

Referenced by osl::effect::NumSimpleEffectTable::doBlockAt(), osl::effect::NumSimpleEffectTable::doEffectLong(), osl::Piece::EMPTY(), and osl::NumEffectState::findLongAttackAt().

## EndgameIndex

const int osl::EndgameIndex = EvalStages-1

Definition at line 16 of file midgame.h.

Referenced by osl::eval::ml::OpenMidEndingEval::doResetWeights(), osl::eval::ml::OpenMidEndingEval::endgameValue(), osl::eval::ml::OpenMidEndingEval::setRandom(), and osl::eval::ml::King25EffectEachBothEnding::setUp().

## EvalStages

const int osl::EvalStages = 4

Definition at line 12 of file midgame.h.

Referenced by osl::eval::ml::King25EffectEachXY::setUp().

## NStages

const int osl::NStages = 4

Definition at line 11 of file midgame.h.

Referenced by osl::eval::ml::King25EmptyAbs< false >::eval(), osl::eval::ml::AttackMajorsInBase::setUp(), osl::eval::ml::BishopBishopPiece::setUp(), osl::eval::ml::BishopEffectPiece::setUp(), osl::eval::ml::BishopEffectPieceKingRelative::setUp(), osl::eval::ml::BishopHead::setUp(), osl::eval::ml::BishopHeadKingRelative::setUp(), osl::eval::ml::BishopHeadX::setUp(), osl::eval::ml::BishopMobilityEach::setUp(), osl::eval::ml::BishopRookFork::setUp(), osl::eval::ml::BishopSilverKnight::setUp(), osl::eval::ml::BishopStandFile5::setUp(), osl::eval::ml::CanCheckNonPawnPieceStandCombination::setUp(), osl::eval::ml::CheckShadowPtype::setUp(), osl::eval::ml::GoldAndSilverNearKing::setUp(), osl::eval::ml::GoldAndSilverNearKingCombination::setUp(), osl::eval::ml::GoldKnightKingRelative::setUp(), osl::eval::ml::GoldSideMove::setUp(), osl::eval::ml::King25BothSide::setUp(), osl::eval::ml::King25BothSideX::setUp(), osl::eval::ml::King25BothSideY::setUp(), osl::eval::ml::King25Effect2::setUp(), osl::eval::ml::King25Effect3::setUp(), osl::eval::ml::King25Effect3Y::setUp(), osl::eval::ml::King25EffectCountCombination::setUp(), osl::eval::ml::King25EffectCountCombinationY::setUp(), osl::eval::ml::King25EffectEachKXY::setUp(), osl::eval::ml::King25EffectEachXY::setUp(), osl::eval::ml::King25EffectSupported::setUp(), osl::eval::ml::King25EffectY2::setUp(), osl::eval::ml::King25Mobility::setUp(), osl::eval::ml::King25MobilityX::setUp(), osl::eval::ml::King25MobilityY::setUp(), osl::eval::ml::King3Pieces::setUp(), osl::eval::ml::King3PiecesXY::setUp(), osl::eval::ml::KingMobility::setUp(), osl::eval::ml::KingMobilitySum::setUp(), osl::eval::ml::KingMobilityWithBishop::setUp(), osl::eval::ml::KingMobilityWithRook::setUp(), osl::eval::ml::KingPieceRelativeNoSupport::setUp(), osl::eval::ml::KingRookBishop::setUp(), osl::eval::ml::KingXBlocked3::setUp(), osl::eval::ml::KingXBlocked3Y::setUp(), osl::eval::ml::KingXBothBlocked::setUp(), osl::eval::ml::KingXBothBlockedY::setUp(), osl::eval::ml::KnightCheckY::setUp(), osl::eval::ml::KnightFork::setUp(), osl::eval::ml::KnightHead::setUp(), osl::eval::ml::KnightHeadOppPiecePawnOnStand::setUp(), osl::eval::ml::LanceEffectPieceKingRelative::setUp(), osl::eval::ml::MajorCheckWithCapture::setUp(), osl::eval::ml::NonPawnAttacked::setUp(), osl::eval::ml::NonPawnAttackedKingRelative::setUp(), osl::eval::ml::NonPawnAttackedPtype::setUp(), osl::eval::ml::NonPawnAttackedPtypePair::setUp(), osl::eval::ml::NonPawnPieceStandCombination::setUp(), osl::eval::ml::NonPawnPieceStandTurn::setUp(), osl::eval::ml::NumPiecesBetweenBishopAndKingAll::setUp(), osl::eval::ml::NumPiecesBetweenBishopAndKingOpp::setUp(), osl::eval::ml::NumPiecesBetweenBishopAndKingSelf::setUp(), osl::eval::ml::PawnDropNonDrop::setUp(), osl::eval::ml::PawnDropPawnStand::setUp(), osl::eval::ml::PawnDropPawnStandX::setUp(), osl::eval::ml::PawnDropPawnStandY::setUp(), osl::eval::ml::PawnDropX::setUp(), osl::eval::ml::PawnPtypeOPtypeO::setUp(), osl::eval::ml::PawnPtypeOPtypeOY::setUp(), osl::eval::ml::PawnStateKingRelative::setUp(), osl::eval::ml::PieceStandCombinationBoth::setUp(), osl::eval::ml::PieceStandY::setUp(), osl::eval::ml::PinPtype::setUp(), osl::eval::ml::PinPtypeDistance::setUp(), osl::eval::ml::PinPtypePawnAttack::setUp(), osl::eval::ml::PromotedMinorPieces::setUp(), osl::eval::ml::PromotedMinorPiecesY::setUp(), osl::eval::ml::Promotion37::setUp(), osl::eval::ml::PtypeCombination::setUp(), osl::eval::ml::PtypeCount::setUp(), osl::eval::ml::PtypeCountXY::setUp(), osl::eval::ml::PtypeCountXYAttack::setUp(), osl::eval::ml::PtypeYPawnY::setUp(), osl::eval::ml::PtypeYY::setUp(), osl::eval::ml::RookEffectPiece::setUp(), osl::eval::ml::RookEffectPieceKingRelative::setUp(), osl::eval::ml::RookMobilitySum::setUp(), osl::eval::ml::RookMobilitySumKingX::setUp(), osl::eval::ml::RookMobilityX::setUp(), osl::eval::ml::RookMobilityXKingX::setUp(), osl::eval::ml::RookMobilityY::setUp(), osl::eval::ml::RookPawnY::setUp(), osl::eval::ml::RookPawnYX::setUp(), osl::eval::ml::RookPromoteDefense::setUp(), osl::eval::ml::RookPromoteDefenseRookH::setUp(), osl::eval::ml::RookRook::setUp(), osl::eval::ml::RookRookPiece::setUp(), osl::eval::ml::RookSilverKnight::setUp(), osl::eval::ml::SilverAdvance26::setUp(), osl::eval::ml::SilverFork::setUp(), and osl::eval::ml::SilverHeadPawnKingRelative::setUp().

## Path_Encoding_Table

osl::PathEncodingTable osl::Path_Encoding_Table

extern

Definition at line 8 of file pathEncoding.cc.

Referenced by osl::PathEncoding::popMove(), and osl::PathEncoding::pushMove().

## Piece_Table

const PieceTable osl::Piece_Table

Definition at line 94 of file tables.cc.

Referenced by osl::NumEffectState::findThreatenedPiece(), osl::SimpleState::init(), osl::SimpleState::isConsistent(), osl::progress::PtypeProgress::PtypeProgress(), osl::NumEffectState::selectCheapPiece(), osl::SimpleState::setPiece(), osl::SimpleState::setPieceAll(), osl::csa::show(), osl::NumEffectState::showEffect(), and osl::book::MiniBoardChar50::toSimpleState().

## PTYPE_SIZE

const int osl::PTYPE_SIZE =PTYPE_MAX-PTYPE_MIN+1

Definition at line 107 of file basic_type.h.

Referenced by osl::move_probability::King5x5Ptype::addOne(), osl::move_probability::AttackFromOpposingSliders::AttackFromOpposingSliders(), osl::move_probability::AttackToOpposingSliders::AttackToOpposingSliders(), osl::eval::ml::BishopRookFork::bishopIndex(), osl::move_probability::CapturePtype::CapturePtype(), osl::move_probability::CheckFeature::CheckFeature(), osl::eval::ml::OpenMidEndingEval::doResetWeights(), osl::move_probability::DropCaptured::DropCaptured(), osl::eval::ml::CheckShadowPtype::evalOne(), osl::eval::ml::PinPtypeAll::evalOne(), osl::move_probability::FromEffect::FromEffect(), osl::move_probability::FromEffectLong::FromEffectLong(), osl::eval::ml::BishopBishopPiece::index(), osl::eval::ml::KnightFork::index(), osl::eval::ml::MajorGoldSilverAttacked< Opening >::index(), osl::eval::ml::NonPawnAttacked::index(), osl::eval::ml::NonPawnAttackedPtype::index(), osl::eval::ml::RookRookPiece::index(), osl::eval::ml::NonPawnAttackedPtypePair::index1(), osl::eval::ml::NonPawnAttackedPtypePair::index2(), osl::eval::ml::NonPawnAttacked::indexK(), osl::PathEncodingTable::init(), osl::move_probability::AttackFromOpposingSliders::match(), osl::move_probability::AttackKing8Long::match(), osl::move_probability::AttackToOpposingSliders::match(), osl::move_probability::BreakThreatmate::match(), osl::move_probability::CapturePtype::match(), osl::move_probability::CheckFeature::match(), osl::move_probability::CheckmateIfCapture::match(), osl::move_probability::CoverFork::match(), osl::move_probability::CoverPawn::match(), osl::move_probability::EscapeThreatened::match(), osl::move_probability::FromEffect::match(), osl::move_probability::KingRelativeX::match(), osl::move_probability::KingRelativeY::match(), osl::move_probability::LureDefender::match(), osl::move_probability::MoveFromOpposingSliders::match(), osl::move_probability::PromotionBySacrifice::match(), osl::move_probability::SacrificeAttack::match(), osl::move_probability::SquareX::match(), osl::move_probability::SquareY::match(), osl::move_probability::ThreatmateByCapture::match(), osl::move_probability::ToEffect::match(), osl::move_probability::PawnAttack::matchPtype(), osl::move_probability::MoveFromOpposingSliders::MoveFromOpposingSliders(), osl::eval::ml::BishopRookFork::setUp(), osl::eval::ml::KnightFork::setUp(), osl::eval::ml::NonPawnAttackedKingRelative::setUp(), osl::eval::ml::NonPawnAttackedPtypePair::setUp(), osl::progress::ml::NewProgress::setUp(), osl::move_probability::PawnAttack::squareStatus(), osl::move_probability::SquareX::SquareX(), osl::move_probability::ToEffect::supportAttack(), osl::move_probability::ToEffect::ToEffect(), and osl::move_probability::ToEffectLong::ToEffectLong().

## Ptype_Table

const PtypeTable osl::Ptype_Table

Definition at line 97 of file tables.cc.

Referenced by osl::checkmate::Dfpn::attack(), osl::checkmate::OracleAdjust::attack(), osl::PieceStand::canAdd(), osl::ShouldPromoteCut::canIgnore(), osl::SimpleState::countPiecesOnStandBit(), osl::effect_action::AlwaysMove< Action >::doAction(), osl::effect_action::BetterToPromote< Action >::doAction(), osl::rating::DropCaptured::DropCaptured(), osl::effect::EffectedNumTable::EffectedNumTable(), osl::rating::EscapePin::EscapePin(), osl::eval::ml::PieceStand::eval(), osl::eval::ml::PieceStand::evalWithUpdate(), osl::effect_util::AdditionalEffect::find(), osl::eval::See::findAdditionalPieces(), osl::rating::EscapePinGroup::findMatch(), osl::effect_util::Neighboring8Direct::Table::findNearest(), osl::NumEffectState::findThreatenedPiece(), osl::checkmate::Dfpn::generateCheck(), osl::move_generator::PieceOnBoard< Action, noCapturePromote >::generatePieceUnsafe(), osl::effect_util::Neighboring8Direct::Table::hasEffect(), osl::NumEffectState::hasEffectIf(), osl::effect_util::Neighboring8Direct::hasEffectNaive(), osl::effect_util::Neighboring8Direct::Table::hasEffectOrAdditional(), osl::rating::ImmediateAddSupport::ImmediateAddSupport(), osl::checkmate::ImmediateCheckmateTable::ImmediateCheckmateTable(), osl::rating::ImmediateEscape::ImmediateEscape(), osl::eval::ml::NonPawnPieceStandTurn::index(), osl::eval::ml::PieceStandY::index(), osl::rating::ImmediateAddSupport::index(), osl::eval::ml::PtypeCount::indexBoardCount(), osl::eval::ml::PtypeCount::indexBoardCountX(), osl::eval::ml::PtypeCount::indexBoardCountY(), osl::eval::ml::PtypeCount::indexCount(), osl::eval::ml::PtypeCount::indexCountX(), osl::eval::ml::PtypeCount::indexCountY(), osl::checkmate::ProofNumberTable::init(), osl::effect_util::Neighboring8Direct::Table::init(), osl::effect_util::SendOffSquare::Table::init(), osl::NumEffectState::inUnblockableCheck(), osl::SimpleState::isAlmostValidMove(), osl::move_probability::BreakThreatmate::isDefendingThreatmate(), osl::move_classifier::KingOpenMove< P >::isMemberMain(), osl::SimpleState::isValidMoveByRule(), osl::rating::KingEscape::KingEscape(), osl::move_probability::AddEffectLong::match(), osl::rating::EscapePin::match(), osl::book::MiniBoardChar50::MiniBoardChar50(), osl::mobility::MobilityTable::MobilityTable(), osl::rating::AttackKing8::name(), osl::rating::Chase::name(), osl::rating::DefenseKing8::name(), osl::rating::DropPtype::name(), osl::rating::LongTarget2::name(), osl::rating::LongTarget::name(), osl::rating::Pattern::name(), osl::rating::PatternLong2::name(), osl::rating::PatternLong::name(), osl::rating::PinAttack::name(), osl::rating::RelativeKingX::name(), osl::rating::RelativeKingY::name(), osl::progress::ml::NewProgress::NewProgress(), operator<<(), osl::rating::PatternBlock::PatternBlock(), osl::rating::PatternBlockGroup::PatternBlockGroup(), osl::NumEffectState::prologueDrop(), osl::rating::PtypeAttacked::PtypeAttacked(), osl::eval::ml::PieceStandY::setUp(), osl::eval::ml::PtypeCountXY::setUp(), osl::eval::ml::PtypeCountXYAttack::setUp(), osl::csa::show(), osl::ki2::show(), osl::csa::strToPtype(), osl::progress::ml::NewProgress::updateMain(), and osl::move_probability::StateInfo::updatePinnedGenerals().

## PTYPEO_EMPTY

const PtypeO osl::PTYPEO_EMPTY =newPtypeO(BLACK,PTYPE_EMPTY)

Definition at line 303 of file basic_type.h.

Referenced by osl::Move::capturePtypeOSafe(), osl::eval::ml::PawnPtypeOPtypeO::evalWithUpdate(), and osl::eval::ml::BishopHeadKingRelative::setUp().

## PTYPEO_SIZE

const int osl::PTYPEO_SIZE =PTYPEO_MAX-PTYPEO_MIN+1

Definition at line 308 of file basic_type.h.

Referenced by osl::eval::ml::PiecePair::IndexTable::amplify(), osl::eval::ml::PiecePair::compile(), osl::move_probability::BlockLong::makeLongAttackOne(), osl::CArray< Move, 8 >::operator[](), and osl::CArray< Move, 8 >::operator[]().